local uci = require "luci.model.uci".cursor()
local ds = require "luci.dispatcher"
local sys = require "luci.sys"

m = Map("modbus-rtu-to-tcp", "", "")
section_global = m:section(NamedSection, "global","global", translate("Enable/ Disable"))
section_global.anonymous = false
section_global.addremove = false
section_global.name = "global"

option_enabled = section_global:option(Flag, "enabled", translate("Enabled"),
	translate("Enable Modbus RTU To TCP"))
option_enabled.rmempty=false
option_enabled.default="1"


s = m:section(TypedSection, "modbus_rtu_to_tcp", "Modbus RTU To TCP Configuration")
s.anonymous = true

--dbglvl = s:option(Value, "dbglvl","DGBLVL")
--dbglvl.datatype = "range(1,32)"

--logname = s:option(Value, "logname","Logname")
--logname.datatype = "string"

ttyport = s:option(ListValue, "ttyport","Device Name", translate("Serial Port Device Name"))
ttyport.datatype = "string"
ttyport:value("/dev/ttyS0", "Serial Port 1")
ttyport:value("/dev/ttyUSB0", "USB to Serial Converter")
ttyport.default ="/dev/ttyS0"

ttyspeed = s:option(ListValue, "ttyspeed", translate("Baud rate"))
ttyspeed:value("300", "300")
ttyspeed:value("1200", "1200")
ttyspeed:value("2400", "2400")
ttyspeed:value("4800", "4800")
ttyspeed:value("9600", "9600")
ttyspeed:value("19200", "19200")
ttyspeed:value("38400", "38400")
ttyspeed:value("57600", "57600")
ttyspeed:value("115200", "115200")
ttyspeed.default = "115200"


ttymode = s:option(ListValue, "ttymode", translate("Serial Port Mode"))
ttymode.datatype = "string"
ttymode:value("8N1", "8-N-1")
ttymode:value("8E1", "8-E-1")
ttymode:value("8O1", "8-O-1")


trxcntl = s:option(ListValue, "trxcntl","Control Type", translate("RS-485 Data Direction Control Type"))
trxcntl:value("0","ADDC")
trxcntl:value("1","by RTS")

serveraddr = s:option(Value, "serveraddr","Server Address", translate("TCP server address to bind"))
serveraddr.datatype = "ipaddr"
serveraddr.default = "0.0.0.0"

serverport = s:option(Value, "serverport","Server Port",translate("TCP server port number"))
serverport.datatype = "port"
serverport.default = 502

maxconn = s:option(Value, "maxconn","Max Connection", translate("Maximum number of simultaneous TCP connections"))
maxconn.datatype = "range(1,32)"
maxconn.default = 4

maxtry = s:option(Value, "maxtry","Maximum Retries", translate("Maximum Number Of Request Retries"))
maxtry.datatype = "range(1,3)"
maxtry.default = 2

conntimeout = s:option(Value, "conntimeout","Connection Timeout")
conntimeout.datatype = "integer"

rqstpause = s:option(Value, "rqstpause","Request Pause", translate("Pause between requests in milliseconds"))
rqstpause.datatype = "integer"

respwait = s:option(Value, "respwait","Response Wait", translate("Response wait time in milliseconds"))
respwait.datatype = "integer"

return m